program WW2;   { World War II }

uses Dos, Crt, Graph, Inp, Marek, CGAmarek, Scr;

const Key2 : set of Char = ['Z', 'X', 'C', 'A', 'D', 'Q', 'W', 'E'];

type
     _Suradnice = record
		   X, Y: integer;
		  end;

     _Smer = 1..16;

     _Farby = 0..3;

     _Pole = array[1..20, 1..20] of _Farby;

     _cTanku = 1..2;

     _Tank = record
	      Size: word;
	      X, Y, OldX, OldY: Integer;
	      Img: array[0..16] of Pointer;
	      Skok: Integer;
	      Smer, OldSmer: _Smer;
	     end;

   _Strela = record
	      Size: word;
	      X, Y, OldX, OldY: integer;
	      Img: array[1..16] of pointer;
	      Skok: integer;
	      Smer: _Smer;
	      Leti: boolean;
	     end;

    _Vybuch = record
	       Img: array[0..16] of pointer;
	       Del: array[1..16] of byte;
	       Hz: array[1..16] of word;
	      end;


var
    Ch: Char;
    Pressed: array[1..83] of boolean;
     OldKbd: procedure;
    rr, Bt, I, J, K, L, M: Byte;
    POMsmer: _Smer;
    Tank: array[1..2] of _Tank;
    Strela: array[1..2, 1..3] of _Strela;
    Vybuch: _Vybuch;
    Pole: _Pole;
    Subor: file of _Pole;
    Zasah: array[1..2] of word;
    Size: word;

procedure Hodnoty;
begin
 for I := 1 to 2 do Zasah[I] := 0;
 InitZvuk;
end;

procedure NewKbd; interrupt;
var Code, Pom: byte;
begin
 Code := port[$60];
 Pom := port[$61];
 port[$61] := Pom or $80;
 port[$61] := Pom;
 port[$20] := $20;
 if Code in [1..83] then Pressed[Code] := TRUE;
 if Code in [129..211] then Pressed[Code - 128] := FALSE;
end;
procedure SetNewKbd;
var I: byte;
begin
  for I := 1 to 83 do Pressed[I] := FALSE;
  GetIntVec(09, @OldKbd);
  SetIntVec(09, Addr(NewKbd));
end;
procedure SetOldKbd;
begin
  SetIntVec(09, Addr(OldKbd));
end;


function Je(A, B, C: integer): boolean;
begin
 if (A >= B) AND (A <= C) then Je := TRUE else Je := FALSE;
end;

function Je4(A1, A2, B1, B2: integer): boolean;
begin
 Je4 := FALSE;
 if (A2 >= B1) AND (A1 <= B2) then Je4 := TRUE;
end;

procedure InitCga;
var Cga, Mode: Integer;
begin
 Cga := 1;
 Mode := 1;
 ZiadneBgi; 
 InitGraph(Cga, Mode, '');
end;


procedure Vypln(X, Y: Integer; Color, Border: Word);
begin
 SetFillStyle(1, Color);
 FloodFill(X, Y, Border);
end;


function RozlysFarbyTankov(Tank: _cTanku; Farba: _Farby): _Farby;
var FF: _Farby;
begin
 if Tank = 1 then
  case Farba of
   0: FF := 0;
   1: FF := 1;
   2: FF := 2;
   3: FF := 3;
  end;
 if Tank = 2 then
  case Farba of
   0: FF := 0;
   1: FF := 2;
   2: FF := 1;
   3: FF := 3;
  end;
 RozlysFarbyTankov := FF;
end;


procedure Definuj;
begin
 Assign(Subor, 'WW2-TANK.DAT');
 {$R-,S-}
 for I := 1 to 2 do with Tank[I] do
  begin
   X := 0;
   Y := 0;
   OldX := 20;
   OldY := 20;
   Skok := 2;
   Smer := 9;
   OldSmer := 1;  { aby to na zaciatku aj nakreslilo}
   Size := ImageSize(X, Y, OldX, OldY);
   Reset(Subor);

   GetMem(Img[0], Size);
   GetImage(0, 179, 21, 199, Img[0]^);
   for J := 1 to 16 do
    begin
     Read(Subor, Pole);
     for K := 1 to 20 do for L := 1 to 20 do if Pole[K, L] > 0 then
       PutPixel(J * 20 - 21 + K, L + I * 25, RozlysFarbyTankov(I, Pole[K, L]));
     GetMem(Img[J], Size);
     GetImage(J*20-20+X,Y+I*25,OldX+J*20-20,OldY+I*25,Img[J]^);
    end;

   X := 100;
   Y := 100;
   OldX := X;
   OldY := Y;
  end;
 Close(Subor);
 Inc(Tank[2].X, 120);
 Tank[2].OldX := Tank[2].X;

 {-------- STRELY ---------------------}
 Assign(Subor, 'WW2-FIRE.DAT');
     Reset(Subor);
     with Strela[1, 1] do
       begin
	 X := 1;
	 Y := 1;
	 OldX := 20;
	 OldY := 20;
	 Skok := 2;
	 Leti := FALSE;
	 Size := ImageSize(X, Y, OldX, OldY);

		{   SetColor(Color);             }
		{   Ellipse(3, 3, 0, 360, 1, 1); }
		{   Vypln(3, 3, Color, Color);   }

	 for J := 1 to 16 do
	   begin
	     Read(Subor, Pole);
	     for K := 1 to 20 do for L := 1 to 20 do if Pole[K, L] > 0 then
	       PutPixel(J*20-21+K,L+I*25+50,RozlysFarbyTankov(I, Pole[K, L]));
	     GetMem(Img[J], Size);
	     GetImage(J*20-20+X,Y+I*25+50,OldX+J*20-20,OldY+I*25+50,Img[J]^);
	   end;
       end;
     Strela[1, 2] := Strela[1, 1];
     Strela[1, 3] := Strela[1, 1];

 Strela[2] := Strela[1];
 Close(Subor);

 {----------   VYBUCH -----------}
 Assign(Subor, 'WW2-BLOW.DAT');
 Reset(Subor);
 Size := ImageSize(0, 0, 20, 20);

 with Vybuch do begin

   Hz[01] := 0900;  Del[01] := 30;
   Hz[02] := 3400;  Del[02] := 40;
   Hz[03] := 7550;  Del[03] := 50;
   Hz[04] := 6256;  Del[04] := 60;
   Hz[05] := 6300;  Del[05] := 70;
   Hz[06] := 1234;  Del[06] := 80;
   Hz[07] := 1530;  Del[07] := 90;
   Hz[08] := 1250;  Del[08] := 70;
   Hz[09] := 1243;  Del[09] := 40;
   Hz[10] := 2300;  Del[10] := 30;
   Hz[11] := 1200;  Del[11] := 20;
   Hz[12] := 2345;  Del[12] := 10;
   Hz[13] := 5450;  Del[13] := 40;
   Hz[14] := 1430;  Del[14] := 30;
   Hz[15] := 5456;  Del[15] := 20;
   Hz[16] := 4500;  Del[16] := 10;

   GetMem(Img[0], Size);
   GetImage(0, 179, 21, 199, Img[0]^);
   for J := 1 to 16 do
     begin
       Read(Subor, Pole);
       for K := 1 to 20 do for L := 1 to 20 do if Pole[K, L] > 0 then
	 PutPixel(J * 20 - 21 + K, L + 150, Pole[K, L]);
       GetMem(Img[J], Size);
       GetImage(J*20-20, 150, J*20, 150 + 20, Img[J]^);
     end;
 end;
 Close(Subor);
 {--------------------------}

 {$R+,S+}
 ClearDevice;
end;


procedure ZmenXY(Smer: _Smer; Skok: Integer; var X, Y: Integer);
begin
  case Smer of
   01: Inc(Y, Skok);
   02: begin Inc(Y, Skok); Inc(X, Skok div 2); end;
   03: begin Inc(X, Skok); Inc(Y, Skok) end;
   04: begin Inc(X, Skok); Inc(Y, Skok div 2); end;
   05: Inc(X, Skok);
   06: begin Inc(X, Skok); Dec(Y, Skok div 2); end;
   07: begin Inc(X, Skok); Dec(Y, Skok) end;
   08: begin Dec(Y, Skok); Inc(X, Skok div 2); end;
   09: Dec(Y, Skok);
   10: begin Dec(Y, Skok); Dec(X, Skok div 2); end;
   11: begin Dec(X, Skok); Dec(Y, Skok) end;
   12: begin Dec(X, Skok); Dec(Y, Skok div 2); end;
   13: Dec(X, Skok);
   14: begin Dec(X, Skok); Inc(Y, Skok div 2); end;
   15: begin Dec(X, Skok); Inc(Y, Skok) end;
   16: begin Inc(Y, Skok); Dec(X, Skok div 2); end;
  end;
end;

procedure XNakresli(Kt: _cTanku);
begin
  with Tank[Kt] do begin
    PutImage(OldX, OldY, Img[0]^, 0);
    PutImage(X, Y, Img[Smer]^, 0);
  end;
end;

procedure Nakresli(Kt: _cTanku);
const Cir = 20;
var L: byte;
begin
 with Tank[Kt] do if (X <> OldX) OR (Y <> OldY) OR (OldSmer <> Smer) then
  begin
   PutImage(OldX, OldY, Img[0]^, 0);
   PutImage(X, Y, Img[Smer]^, 0);
  end;
end;


procedure preStrielaj(var Strela: _Strela; Kt: _cTanku);
begin
 Zvuk;
 with Strela do
  begin
     X := Tank[Kt].X;
     Y := Tank[Kt].Y;
     Smer := Tank[Kt].Smer;
     Leti := TRUE;
     ZmenXY(Smer, 20, X, Y);
     OldX := X;
     OldY := Y;
  end;
end;

procedure Strielaj(Kt: _cTanku);
begin
 if Strela[Kt, 1].Leti = FALSE then preStrielaj(Strela[Kt, 1], Kt)
 else if Strela[Kt, 2].Leti = FALSE then preStrielaj(Strela[Kt, 2], Kt)
 else if Strela[Kt, 3].Leti = FALSE then preStrielaj(Strela[Kt, 3], Kt);
end;

procedure Trefa(Strl, Cstrely, L: byte);
const hY : array[1..2] of byte = (180, 190);
var St1, St2: string; I: byte;
begin
  with Strela[Strl, Cstrely] do begin
    PutImage(X, Y, Img[Smer]^, 1);
    Leti := FALSE;
    XNakresli(L);

    for I := 1 to 16 do
      begin
       PutImage(Tank[L].X, Tank[L].Y, Vybuch.Img[I]^, 0);
       Sound(Vybuch.Hz[I]);
       Delay(Vybuch.Del[I]);
      end;
    Nosound;
    with Tank[L] do PutImage(X, Y, Img[Smer]^, 0);
  end;

  SetColor(0);
  Str(L, St1);
  Str(Zasah[L], St2);
  OutTextXY(0, hY[L], St1 + ': ' + St2);
  Inc(Zasah[L]);
  SetColor(3);
  Str(L, St1);
  Str(Zasah[L], St2);
  OutTextXY(0, hY[L], St1 + ': ' + St2);
end;


procedure HybStrely;
begin
 for I := 1 to 2 do for K := 1 to 3 do
  with Strela[I, K] do if Leti then
  begin
   PutImage(OldX, OldY, Img[Smer]^, 1);
   PutImage(X, Y, Img[Smer]^, 0);
   OldX := X;
   OldY := Y;
   if I = 1 then L := 2 else L := 1;

   if (Je4(X, X + 15, Tank[L].X, Tank[L].X + 15)) AND
      (Je4(Y, Y + 15, Tank[L].Y, Tank[L].Y + 15))
       then  Trefa(I, K, L);
   ZmenXY(Smer, Skok, X, Y);
  end;

end;

procedure Plus(var Smer: _Smer);
begin
 if Smer = 16 then Smer := 1 else Inc(Smer);
end;

procedure Minus(var Smer: _Smer);
begin
 if Smer = 1 then Smer := 16 else Dec(Smer);
end;

procedure Koniec;
begin
  SetOldKbd;
  Halt(0);
end;

{-----------------   NOVE KLAVESY NA NOVY SPUOSOB !!! ----------}
procedure Klavesy;
begin
  if Pressed[1] then Koniec;   { ESC }

  with Tank[2] do begin
    OldX := X;
    OldY := Y;
    OldSmer := Smer;

    if Pressed[30] then Plus(Smer);    { A-VLAVO  }
    if Pressed[32] then Minus(Smer);   { D-VPRAVO }
    if Pressed[45] then ZmenXY(Smer, (-1) * Skok, X, Y);       { X-DOLE }
    if Pressed[17] then ZmenXY(Smer, Skok, X, Y);              { W-HORE }

    if Pressed[31] then begin Strielaj(2); Pressed[31] := FALSE; end; { S }

    Nakresli(2);
    OldSmer := Smer;
  end;

  with Tank[1] do begin
    OldX := X;
    OldY := Y;
    OldSmer := Smer;

    if Pressed[75] then Plus(Smer);    { VLAVO  }
    if Pressed[77] then Minus(Smer);   { VPRAVO }
    if Pressed[80] then ZmenXY(Smer, (-1) * Skok, X, Y);       { DOLE }
    if Pressed[72] then ZmenXY(Smer, Skok, X, Y);              { HORE }

    if Pressed[76] then begin Strielaj(1); Pressed[76] := FALSE end; { 5 }

    Nakresli(1);
    OldSmer := Smer;
  end;
end;

procedure Pozadie;
type Pole6040 = array[1..60, 1..40] of _Farby;
var Size: word; Tapeta: pointer; Subor: file of Pole6040; Pole: Pole6040;
    X, Y: integer;
begin
 Assign(Subor, 'WW2-BACK.DAT');
 Reset(Subor);
 Read(Subor, Pole);
 Close(Subor);
 for X := 1 to 60 do for Y := 1 to 40 do PutPixel(X, Y, Pole[X, Y]);
 Size := ImageSize(1, 1, 60, 40);
 GetMem(Tapeta, Size);
 GetImage(1, 1, 60, 40, Tapeta^);
 ClearDevice;
 {----}
 for X := 1 to 5 do for Y := 1 to 5 do PutImage(X * 60 - 50, Y * 40 - 40, Tapeta^, 0);
end;


begin
  Hodnoty;
  InitCga;
  Definuj;
  Pozadie;
  for I := 1 to 2 do with Tank[I] do begin Nakresli(I); OldSmer := Smer; end;
  SetNewKbd;
    repeat
      Klavesy;
      HybStrely;
      for I := 1 to 2 do for J := 1 to 3 do if not Strela[I, J].Leti then
	Delay(15);
    until GraphResult <> 0;
  SetOldKbd;
  OutText(' ERROR !!!');
end.
